/*
 * DataPlayfield.h
 *
 *  Created on: Mar 22, 2010
 *      Author: roger
 */

#ifndef DATAPLAYFIELD_H_
#define DATAPLAYFIELD_H_

#include <string>
#include <iostream>
#include <fstream>
#include <sstream>

#include "kernel.hpp"
#include "temporalskindata.hpp"
#include "testafferents.hpp"
#include "misc.hpp"

using namespace std;

class DataPlayfield
{
public:
    DataPlayfield(int anb_l,int anb_c,string aFile);
    virtual ~DataPlayfield();

    /* variables */
    float rr;							// first radius of gaussian kernel
    float rr2;                                                  // second radius of gaussian kernel
    string outputFile;                                          // result file address
    int nb_l;							// number of lines of data matrix
    int nb_c;							// number of columns of data matrix
    double** lastData;                                          // previous data measurement
    float timeWindow;                                 // now useless ??
    vector<Kernel> listOfKernels;                               // list of Gaussian kernels
    double currentTime;                               // time of acquisition of data useless??
    float multFactor;                                           // multiplication factor for data (ie sensibility of neurons)
    float multNoise;                                  // if adding noise (now useless!!)
    double periodAcq;                                 //acquisition period of the skin (now useless ??)
    double simulationTime;                            // now useless ??
    unsigned int nbOfAfferents;                                 // total number of neurons (ie mecanoreceptors)
    TestAfferents *test;					// simulation program class

    /* methods */
    void firstRun(double** dataTab);                            //saves the first data matrix
    void play(double** dataTab);                                //main function, to be run at every iteration
    void prepareNextRun(double **dataTab);           		//prepares the class for next iteration
};

#endif /* DATAPLAYFIELD_H_ */
