//////////////////////////////////////////////////////////////////////////////
//
// (C) Copyright Ion Gaztanaga 2006-2009. Distributed under the Boost
// Software License, Version 1.0. (See accompanying file
// LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
//
// See http://www.boost.org/libs/interprocess for documentation.
//
//////////////////////////////////////////////////////////////////////////////
//[doc_anonymous_semaphore_shared_data
#include <boost/interprocess/sync/interprocess_semaphore.hpp>

struct shared_memory_buffer
{
   enum { NumItemsl = 4 };		//nb matrix lines
   enum { NumItemsc = 6 };		//nb matrix columns
   enum { NumMat = 1 };			//nb of matrixes in shared memory (at one given time)

   shared_memory_buffer()
      : mutex(1), isempty(NumMat),isfull(0), nstored(0)
   {}

   //Semaphores to protect and synchronize access
   boost::interprocess::interprocess_semaphore
      mutex, isempty, isfull, nstored;

   //Items to fill
   double items [NumMat][NumItemsl][NumItemsc];
};
//]
