#include "filethread.h"

fileThread::fileThread(std::string afilename)
{
    filename = afilename;
    DATAchain = new DataFILEClass(filename);
}

fileThread::~fileThread()
{
    writingThread_isrunning = false;
    delete DATAchain;
}

void fileThread::run()
{
    writingThread_isrunning=true;

    double seconds = acq_period; 	// time between two acquisitions (in ms) => #define
    boost::posix_time::ptime endwait = boost::posix_time::ptime(boost::posix_time::microsec_clock::universal_time());
    boost::posix_time::time_duration t_elapsed;

    while(DATAchain->getNbMat()>0 || DATAchain->checkIndex())
    {
        this->setTerminationEnabled(false);
        t_elapsed = boost::posix_time::ptime(boost::posix_time::microsec_clock::universal_time()) - endwait;	// time since last acquisition
        if( DATAchain->checkIndex() && t_elapsed.total_milliseconds()>= seconds)				// if elapsed time > acquisition time objective
        {
            endwait = endwait + boost::posix_time::milliseconds(seconds);					// updates time of next acquisition
            DATAchain->readNextMatrix();									// read data from file
        }  
        if(DATAchain->getNbMat()>0   && writingSemaphore->tryAcquire(1))                                        // writing in shared memory (when possible)
        {
            for(int i=0;i<NBL;i++)
            {
                for(int j=0;j<NBC;j++)
                {
                    sharedData[i][j]=DATAchain->getMat(i,j);
                }
            }
            sharedTime = DATAchain->getTime();
            readingSemaphore->release(1);
            DATAchain->removeMatrix();
        }
        this->setTerminationEnabled(true);
    }
    writingThread_isrunning=false;
}
