//( hebblearningparameters.hpp

#ifndef HEBBLEARNINGPARAMETERS_HPP
#define HEBBLEARNINGPARAMETERS_HPP

/*****************************************************
 **
 **   Parameters used for the hebbian learning
 **
 ******************************************************/

/**
 *
 * the window time length to compute a mean firing rate and to perform a hebbian learning
 *
 **/
const double rateTimeWindow = 0.1;

/**
 *
 * eta 0 parameter in the Oja's rule
 *
 **/
const double oja_eta0 = 0.00004;

/**
 *
 * constant decrease
 *
 **/
const double weight_decrease = 0.2;

/**
 *
 * for spike-dependant learning, the increase of weight
 *
 **/
const double A_positive = 2.5;//2.500;//0.0250; //5.0 marchait pas trop trop mal

/**
 *
 * for spike-dependant learning, the time constant for decrease (in s)
 *
 **/
const double t_positive = 0.010;//0.015;

/**
 *
 * for spike-dependant learning, the decrease of weight
 *
 **/
const double A_negative = 0.100; //0.0100;
//const double A_negative = 0.0000; //0.0100;

/**
 *
 * for spike-dependant learning, the time constant for decrease (in s)
 *
 **/
const double t_negative = 0.010;//0.030;              //   ATTENTION A LA RELATION «D'EQUILIBRE» A+*T+ <= A-*T-

/**
 *
 * maximum weight for a connection
 *
 **/
const double maxWeight = 500;

/**
 *
 * weight increment when only the presynaptic fires
 *
 **/
const double w_in = -0.0525;//0.00001; //INCREMENT  ----> <0 if ltd

/**
 *
 * weight decrease when only the postsynaptic fires
 *
 **/
const double w_out = 0.0000;//0.0005; // 0.02 // 0.0002;//0.0005;

/**
 *
 * number of cells in map layers
 *
 **/
const int nbOfCellsInMaps = 500;//500

#endif

//) hebblearningparameters.hpp
