//( kernel.cpp



#include "kernel.hpp"


//( Kernel


Kernel::Kernel(int s1, int s2)
{
    size1=s1;
    size2=s2;

    for(int i=0;i<size1;i++)
    {
        vector<double> buf1;
        data.push_back(buf1);

        for(int j=0;j<size2;j++)
        {
            data[i].push_back(0);
        }
    }
}

void Kernel::print(string outputfile)
{
    ofstream outputFile(outputfile.c_str());

    int size1 = 5;
    int size2 = 5;

    for (int j=0;j< size1;j++)
    {
        for (int k=0;k< size2;k++)
        {
            outputFile << data[j][k] << "\t";
        }
        outputFile << endl;
    }

    outputFile.close();
}

void Kernel::print()
{
    int size1 = 5;
    int size2 = 5;

    for (int j=0;j< size1;j++)
    {
        for (int k=0;k< size2;k++)
        {
            cout << data[j][k] << "\t";
        }
        cout << endl;
    }
}

void Kernel::createGaussianKernel(double center1, double center2,double standardDeviation)
{

    //calculer pour chaque point de la grille la distance au centre12 et en déduire la valeur du noyau en ce point

    double sqSD=standardDeviation*standardDeviation;
    double sqDist;
    for (int j=0;j< size1;j++)
    {
        for (int k=0;k< size2;k++)
        {
            sqDist=(j-center1)*(j-center1)+(k-center2)*(k-center2);
            data[j][k]= exp(-0.5*sqDist/sqSD) ;
        }
    }
}

void Kernel::normalize(double desiredSum)
{
    double sum=0.0;
    for (int j=0;j< size1;j++)
    {
        for (int k=0;k< size2;k++)
        {
            sum+=data[j][k];
        }
    }
    double factor=desiredSum/sum;
    for (int j=0;j< size1;j++)
    {
        for (int k=0;k< size2;k++)
        {
            data[j][k]*=factor;
        }
    }
}

vector<Kernel> computeListOfGaussianFullKernel(int size1, int size2, double firstRadius, double secondRadius)
{
    vector<Kernel> result;

    Kernel buf(size1,size2);

    for (int j=0;j< size1;j++)
    {
        for (int k=0;k< size2;k++)
        {
            buf.createGaussianKernel(j,k,firstRadius);
            buf.normalize();
            result.push_back(buf);
        }
    }
    if (secondRadius>0)
    {
        for (int j=0;j< size1;j++)
        {
            for (int k=0;k< size2;k++)
            {
                buf.createGaussianKernel(j,k,secondRadius);
                buf.normalize();
                result.push_back(buf);
            }
        }
    }
    return result;
}

//) Kernel


//) kernel.cpp
