//( kernel.hpp

#ifndef KERNEL_HPP
#define KERNEL_HPP


#include <string>
#include <iostream>
#include <fstream>
#include <vector>
#include <math.h>




using namespace std;
//( Kernel

/**
 * class used to produce artificial data
 *
 * @author Xavier
 * Modified JP
**/
class Kernel
{
public:
    Kernel(int s1, int s2);

    void print(string outputfile);
    void print();
    vector<vector<double> > data;

    int getSize1(){return size1;};
    int getSize2(){return size2;};

    void normalize(double desiredSum=1.0);
    void createGaussianKernel(double center1, double center2,double standardDeviation);

private:
    int size1;
    int size2;
};

vector<Kernel> computeListOfGaussianFullKernel(int size1, int size2, double firstRadius, double secondRadius);


//) Kernel

#endif

//) kernel.hpp
