//( pyramidalcell.cpp


#include "pyramidalcell.hpp"
#include "parameters.hpp"

//( PyramidalCell

PyramidalCell::PyramidalCell(bool hebbLearning, bool presynapticLearning, bool postsynapticLearning) :
  LifNeuron(pyramidalCellResetPotential, pyramidalCellRestingPotential,
	    pyramidalCellFiringThreshold, pyramidalCellMembraneCapacitance,
	    pyramidalCellLeakConductance, pyramidalCellRefractoryPeriod, hebbLearning, presynapticLearning, postsynapticLearning)
{
}


PyramidalCell::~PyramidalCell()
{
}


LifNeuron::NeuronType PyramidalCell::getNeuronType() const
{
  return LifNeuron::PyramidalCell;
}


FiringNeuron * PyramidalCell::createNeuron(bool hebbLearning, bool presynapticLearning, bool postsynapticLearning) const
{
  return new PyramidalCell(hebbLearning, presynapticLearning, postsynapticLearning);
}


//) PyramidalCell


//) pyramidalcell.cpp
