//( pyramidalcell.hpp

#ifndef PYRAMIDALCELL_HPP
#define PYRAMIDALCELL_HPP


#include "lifneuron.hpp"


//( PyramidalCell

/**
 * Neuron as a pyramidal cell
 *
 * @author Thomas
 **/
class PyramidalCell :
  public LifNeuron
{
public:
  /**
   * Default constructor
   * 
   * @param hebbLearning   true if this neuron will perform hebbian learning
   *
   **/
  PyramidalCell(bool hebbLearning = false, bool presynapticLearning = false, bool postsynapticLearning = false);

  /**
   * Default destructor
   *
   **/
  ~PyramidalCell();

public:
  /**
   *
   *
   * @return  the type of this neuron
   *
   **/
  NeuronType getNeuronType() const;

public:
  /**
   *
   *
   * @return  a new neuron of the same nature of this one
   *
   **/
  FiringNeuron * createNeuron(bool hebbLearning = false, bool presynapticLearning = false, bool postsynapticLearning = false) const;

protected:

private:

}
;

//) PyramidalCell


#endif

//) pyramidalcell.hpp
