#include "rawdisplay.h"
#include "ui_rawdisplay.h"

RawDisplay::RawDisplay(QWidget *parent) :
        QDialog(parent),
        m_ui(new Ui::RawDisplay)
{
    m_ui->setupUi(this);

    int nb_l = 4;
    int nb_c = 6;
    int size = 40;
    int inter_size = 4;
    int a_size = size + inter_size;
    int xs = 20;                           // horizontal axis
    int ys = 20;

    for(int i = 0;i<nb_l;i++)
    {
        for(int j = 0;j<nb_c;j++)
        {
            rawMatDisplay[i*nb_c+j] = new QTextEdit(this);
            rawMatDisplay[i*nb_c+j]->setGeometry(QRect(xs+a_size*i, ys+a_size*j, size, size));
            rawMatDisplay[i*nb_c+j]->setReadOnly(true);
            rawMatDisplay[i*nb_c+j]->setAlignment(Qt::AlignCenter);
        }
    }
}

RawDisplay::~RawDisplay()
{
    delete m_ui;
}

void RawDisplay::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        m_ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void RawDisplay::DisplayMat(double * MAT)
{
//    for(int i=0;i<4;i++)
//    {
//        for(int j=0;j<6;j++)
//        {
//            rawMatDisplay[i*6+j]->setText(QString::number(MAT[i][j]));
//        }
//    }
    for(int i=0;i<24;i++)
    {
        rawMatDisplay[i]->setText(QString::number(MAT[i]));
    }
}
