//( simulationtest.cpp


#include <math.h>
#include <stdio.h>

#include "simulationtest.hpp"
#include "parameters.hpp"



//( SimulationTest

SimulationTest::SimulationTest(const double simulationTime)
{
    numberOfStep = static_cast<int>(simulationTime / timeStep);
    gnuplotPID = 0;
    lastChrono=0;
    startChrono();
}


SimulationTest::~SimulationTest()
{}


void SimulationTest::run()
{
//    startChrono();
    for (int currentStep = 0;currentStep < static_cast<int>((TimeSaveStruct->time_new-TimeSaveStruct->time_old) / (timeStep*1000));currentStep++)
    {
//    	std::cout << currentStep << "   ||   " << numberOfStep << std::endl;
        setConditions();
        nextStep();
        printData();
        printTime();
    }
    edlutSemaphore->acquire(1);
//    puts("EDLUT - RUN");
    eSim->runLetterSeperation();
    eSim->RunSimul();
    edlutSemaphore->release(1);
}


void SimulationTest::printTime()
{
//    int currentStep = static_cast<int>(getCurrentTime() / timeStep);
//    if ( (getChrono() - lastChrono) > 30)
//    {
//        lastChrono = getChrono();
//
//        double stepTime = getChrono() / currentStep;
//        double timeLeft = (numberOfStep - currentStep) * stepTime;
//        cout << "time: " << getCurrentTime() << " sec"
//        << " (" << "timeleft: "
//        << static_cast<int>(timeLeft / 60) << " min "
//        << static_cast<int>(timeLeft) % 60 << " sec"
//        << ")"
//        << endl;
//
//        if (gnuplotPID != 0)
//        {
//            write(filedescriptor[1], gnuplotScript.c_str(), gnuplotScript.length());
//        }
//    }
}


void SimulationTest::startGnuplot(const string & gnuplotScript)
{
    if ( pipe(filedescriptor) != 0)
    {
        perror("can't open pipes to communicate with gnuplot");
        return;
    }
    gnuplotPID = fork();
    if ( gnuplotPID == -1)
    {
        perror("can't create the child process");
        return;
    }
    if (gnuplotPID == 0)
    {
        dup2(filedescriptor[0], fileno(stdin));
        if (execlp("gnuplot", 0) == -1)
        {
            perror("can't run the program gnuplot");
            //exit(0);
            return;
        }
    }

    this->gnuplotScript = "load '" + gnuplotScript + "'\n";
}

//) SimulationTest


//) simulationtest.cpp
