//( spiketimemetric.hpp

#ifndef SPIKETIMEMETRIC_HPP
#define SPIKETIMEMETRIC_HPP


#include <string>
#include <iostream>
#include <fstream>
#include <vector>
#include <list>
#include <cmath>
#include <math.h>

using namespace std;

#ifndef SPIKE_LIST
#define SPIKE_LIST
typedef list<double> SpikeList;
#endif

#ifndef POPULATION_RESPONSE
#define POPULATION_RESPONSE
typedef vector<SpikeList> PopulationResponse;
#endif



/**
 * functions used to compute distances between spike train and population responses
 *
 * @author Xavier
**/
double spikeTimeMetric(SpikeList * spikes1,SpikeList * spikes2,double cost);
double spikeTimeMetricPopulation(PopulationResponse * spikesVector1,PopulationResponse * spikesVector2,double cost);
void testSpikeTimeMetric();

double evaluateInterStimuliDistances(vector<PopulationResponse*> * pop1, vector<PopulationResponse*> * pop2, double cost);
double evaluateIntraStimulusDistances(vector<PopulationResponse*> * pop, double cost);


#endif

//) spiketimemetric.hpp
