//( communicationdevice.hpp

#ifndef COMMUNICATIONDEVICE_HPP
#define COMMUNICATIONDEVICE_HPP


//( CommunicationDevice

/**
 * Generic object used to communicate with another program
 *
 * @author Christian Boucheny
 **/
class CommunicationDevice 
{
public:
  /**
   * Default constructor
   * 
   **/
  CommunicationDevice();

  /**
   * Default destructor
   *
   **/
  ~CommunicationDevice();

  /**
   *
   * Send a block of data
   * 
   * @param   buffer       data to send
   * @param   buffer_size  size of the packet
   *
   * @return  the error signal 
   *
   **/
  virtual int sendBuffer(void* buffer,int buffer_size)=0;

  /**
   *
   * Receive a block of data
   * 
   * @param   buffer       data to send
   * @param   buffer_size  size of the packet
   *
   * @return  the error signal 
   *
   **/
  virtual int receiveBuffer(void* buffer,int buffer_size)=0;

protected:

}
;

//) CommunicationDevice


#endif

//) communicationdevice.hpp
